﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

delegate void LogDelegate(string s);

class X {
	private LogDelegate log;

	public event LogDelegate Log {
		add {
			log += value;
		}
		remove {
			log -= value;
		}
	}

	public void Do() {
		log("begin");
		// ...
		log("end");
	}
}

class Program {
	static void Main(string[] args) {
		LogDelegate log = null;

		// System.NullReferenceException
		// log("Main");

		log += f;
		log("Main");

		log -= f;
		// System.NullReferenceException
		// log("Main");

		//
		//
		//

		X x = new X();

		// Compile Error: The event 'X.Log' can only appear on the left hand side of += or -= (except when used from within the type 'X')
		// x.Log();

		// System.NullReferenceException in .Do()
		// x.Do();

		x.Log += f;
		x.Do();

		x.Log += g;
		x.Do();

		x.Log -= f;
		x.Do();

		x.Log -= g;
		// System.NullReferenceException in .Do()
		// x.Do();
	}

	static void f(string s) {
		Console.WriteLine("f: {0}", s);
	}

	static void g(string s) {
		Console.WriteLine("g: {0}", s);
	}
}

